/*==========================================================================
  Copyright (c) Fabasoft R&D GmbH, A-4020 Linz, 1995-2015.

  All rights reserved. All hardware and software names used are registered
  trade names and/or registered trademarks of the respective manufacturers.

  The user of this computer program acknowledges that the above copyright
  notice, which constitutes the Universal Copyright Convention, will be
  attached at the position in the function of the computer program which the
  author has deemed to sufficiently express the reservation of copyright.
  It is prohibited for customers, users and/or third parties to remove,
  modify or move this copyright notice.
  ==========================================================================*/
package com.apptelemetry.apm.client.feedback;

import java.util.Random;

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.view.View;
import android.widget.CheckBox;
import android.widget.EditText;

import com.apptelemetry.apm.client.APM;
import com.apptelemetry.apm.client.APMReportContent;

public class FeedbackDialogActivity extends Activity {

	public final static String EXTRA_TOPIC = "com.apptelemetry.apm.client.feedback.TOPIC";
	public final static String EXTRA_SCREENSHOT = "com.apptelemetry.apm.client.feedback.SCREENSHOT";

	private APMReportContent screenshot;
	private String topic;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_feedback_dialog);
		screenshot = (APMReportContent) getIntent().getSerializableExtra(EXTRA_SCREENSHOT);
		View cb = findViewById(R.id.cb_send_screenshot);
		cb.setVisibility(screenshot != null ? View.VISIBLE : View.INVISIBLE);
		topic = getIntent().getStringExtra(EXTRA_TOPIC);

	}

	public void submitFeedback(View view) {
		APM apm = APM.getInstance();
		Random rnd = new Random();
		String reportKey = String.valueOf(rnd.nextDouble());
		EditText editText = (EditText) findViewById(R.id.edit_description);

		apm.ReportTx(0, "sendFeedback", reportKey, editText.getText().toString());
		if (screenshot != null) {
			CheckBox cb = (CheckBox) findViewById(R.id.cb_send_screenshot);
			if (cb.isChecked()) {
				apm.ReportContent(reportKey, screenshot);
			}
		}
		if (topic != null) {
			apm.ReportValueTx(0, reportKey, "topic", topic);
		}

		NavUtils.navigateUpFromSameTask(this);
	}

}
