<%@ Page Language="C#" Inherits="WebShop" AutoEventWireup="true"  Codebehind="WebShop.aspx.cs" %>
<html>
    <head>
        <title>Fabasoft app.telemetry OnlineShop Sample</title>
        <style type="text/css">
          .style1
          {
            height: 49px;
          }
          .style2
          {
            height: 144px;
          }
          .style3
          {
            height: 47px;
          }
          .style4
          {
            height: 64px;
          }
          .style5
          {
            height: 49px;
            width: 192px;
          }
          span.serviceoffline
          {
            color: Red;
          }
          span.serviceonline
          {
            color: Green;
          }
        </style>
        <script type="text/javascript" src="softwaretelemetry.js"></script>
        <script type="text/javascript">
            /* <![CDATA[ */
            apm.SetTimeout(2000);
            apm.SetInterval(30000);
            var module = null;
            var context = null;
            initPage = function() {
                // register application with APM Software-Telemetry
                apm.RegisterApplication("Fabasoft app.telemetry", "Demo", "Browser", "browser");
                // register all modules
                module = apm.RegisterModule("Browser");
                module.RegisterEvent(1, "ButtonClicked", "ArticleID");
                module.RegisterEvent(2, "PageLoaded", "event");
                module.RegisterEvent(3, "CheckServices", "");
                module.RegisterEvent(4, "ServiceStatus", "status");
				module.RegisterEvent(5, "Submit Page - Async wait on result", "");
                apm.RegisterFilterValue("Article ID");
            }
            pageOnLoad = function() {
                if (module == null) {
                    initPage();
                }
                if (context != null) {
                    // set the onload event so that we know how long a page load took
                    module.Event(context, 2, apm.LEVEL_LOG, apm.FLAG_NONE, "onload");
                    apm.ReleaseContext(context);
                    apm.Flush();
                    context = null;
                }
                checkServices();
                setInterval("checkServices()", 10000);
            }
            pageBeforeSubmit = function() {
                context = apm.CreateContext(null, "Article ID");
                module.Event(context, 1, apm.LEVEL_LOG, apm.FLAG_NONE, document.getElementById('box').value);
                document.getElementById('apmcontext').value = apm.GetContext(context);
				module.Event(context, 5, apm.LEVEL_NORMAL, apm.FLAG_NONE);
				apm.ReleaseContext(context);
            }
            checkServices = function() {
              var request = null;
              if (window.XMLHttpRequest) {
                request = new XMLHttpRequest();
              } else if (window.ActiveXObject) {
                request = new ActiveXObject("Microsoft.XMLHTTP");
              }
              else {
                request = new XMLHttpRequest();
              }
              if (request == null) return;
              var context = apm.CreateContext(null, "AJAX Request");
              module.Event(context, 3, apm.LEVEL_NORMAL, apm.FLAG_ENTER);
              request.open("GET", "./AJAXHandler.ashx", true);
              apm.SendXMLHttpRequest(request, true, null, function(xmlhttp, context) {
                if (xmlhttp.readyState == 4) {
                  try {
                    var json_obj = eval('(' + xmlhttp.responseText + ')');
                    module.Event(context, 4, apm.LEVEL_NORMAL, apm.FLAG_NONE, "stockService: " + json_obj.stock);
                    updateStatus('stockService', json_obj.stock);
                    module.Event(context, 4, apm.LEVEL_NORMAL, apm.FLAG_NONE, "repositoryService: " + json_obj.repository);
                    updateStatus('repositoryService', json_obj.repository);
                  }
                  catch (e) {
                    module.Event(context, 4, apm.LEVEL_NORMAL, apm.FLAG_NONE, "Exeption(" + e.name + "): " + e.description);
                  }
                }
              }, context);
              module.Event(context, 3, apm.LEVEL_NORMAL, apm.FLAG_LEAVE);
              apm.ReleaseContext(context);
            }
            updateStatus = function(id, status) {
                var handle = document.getElementById(id);
                if (handle) {
                    handle.className = "service" + status;
                    handle.innerHTML = status;
                }
            }
            apm.env.exceptioncallback = function(exobj, msg) {
                alert("Exception:\nObject: " + exobj + "\nMsg: " + msg);
            }
            /* ]]> */
        </script>
    </head>
    <body style="background-image:url('jpg/welcome_HG.jpg'); background-repeat:no-repeat; font-family: Arial" onload="javascript:pageOnLoad();">
        <form runat="server" onsubmit="javascript:pageBeforeSubmit();">
        <asp:HiddenField ID="apmcontext" runat="server" />
        <table style="margin-top:82px; margin-left:10px; " cellpadding="10px" cellspacing="0px">
            <tbody>
              <tr>
              <td class="style1">
                <asp:Label ID="label" Runat="server" style="font-weight: bolder; text-align:right">Please enter Article ID</asp:Label>
              </td>
              <td class="style5">
                <asp:TextBox ID="box" Rows="1" Columns="1"
                  AutoPostBack="false" runat="server" Width="230px" />
              </td>
              <td class="style1" align="right">
                <asp:Button runat="server" ID="button" Text="Check Availability"
                  OnClick="WebShopWebMethod" Width="150px"/>
              </td>
            </tr>

            <tr>
              <td align="right" class="style2">
                <asp:Label ID="desclabel" runat="server" Text="Description" style="font-weight: bolder; text-align:right"></asp:Label>
              </td>
              <td colspan="2" class="style2">
                <asp:TextBox ID="description" runat="server" ReadOnly="True"
                  TextMode="MultiLine" Height="100px" Width="410px"></asp:TextBox>
              </td>
            </tr>
            <tr>
              <td align="right" class="style3">
                <asp:Label ID="availlabel" runat="server" Text="Available" style="font-weight: bolder; text-align:right"></asp:Label>
              </td>
              <td colspan="2" class="style3">
                <asp:TextBox ID="availability" runat="server" ReadOnly="True"
                  TextMode="SingleLine" Width="100%"></asp:TextBox>
              </td>
            </tr>
            <tr valign="bottom">
              <td class="style4" style="font-weight: bolder;" colspan="2">
                Stock Service <span id="stockService" class="serviceoffline">?</span><br />
                Repository Service <span id="repositoryService" class="serviceoffline">?</span></td>
              <td align="right" class="style4">
                <button onclick="window.location.href='./Options.aspx'; return false;" style="width:150px" name="settings" type="button">Settings</button>
              </td>
            </tr>
          </tbody>
        </table>
      </form>
    </body>
</html>
