﻿/* ==========================================================================
 * Copyright (c) Fabasoft R&D GmbH, A-4020 Linz, 1995-2015.
 *
 * All rights reserved. All hardware and software names used are registered
 * trade names and/or registered trademarks of the respective manufacturers.
 *
 * The user of this computer program acknowledges that the above copyright
 * notice, which constitutes the Universal Copyright Convention, will be
 * attached at the position in the function of the computer program which the
 * author has deemed to sufficiently express the reservation of copyright.
 * It is prohibited for customers, users and/or third parties to remove,
 * modify or move this copyright notice.
 * ========================================================================= */

using System;
using System.Collections;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using apm;

namespace OnlineShopCS
{
  [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
  public class AJAXHandler : IHttpHandler
  {

    public void ProcessRequest(HttpContext context)
    {
      WebShop ws = new WebShop();

      // start Software-Stelemetry session
      WebShop.g_application.CreateContext("AJAX Request");
      string strudlcontext = context.Request.Headers.Get("x-apm-telemetry-context");
      try
      {
        byte[] rawcontext = System.Convert.FromBase64String(strudlcontext);
        WebShop.g_application.AttachContext(rawcontext);
      }
      catch
      {
      }

      context.Response.ContentType = "application/json";
      context.Response.Write("{\"stock\":\"");
      if (ws.CheckStockService())
      {
        context.Response.Write("online");
      }
      else
      {
        context.Response.Write("offline");
      }
      context.Response.Write("\",\"repository\":\"");
      if (ws.CheckRepositoryService())
      {
        context.Response.Write("online");
      }
      else
      {
        context.Response.Write("offline");
      }
      context.Response.Write("\"}");
      byte[] syncMark;
      WebShop.g_application.GetSyncMark(out syncMark);
      context.Response.AddHeader("x-apm-telemetry-syncmark", System.Convert.ToBase64String(syncMark));
      // end Software-Telemetry session
      WebShop.g_application.ReleaseContext();
    }

    public bool IsReusable
    {
      get
      {
        return false;
      }
    }
  }
}
