﻿/* ==========================================================================
 * Copyright (c) Fabasoft R&D GmbH, A-4020 Linz, 1995-2015.
 *
 * All rights reserved. All hardware and software names used are registered
 * trade names and/or registered trademarks of the respective manufacturers.
 *
 * The user of this computer program acknowledges that the above copyright
 * notice, which constitutes the Universal Copyright Convention, will be
 * attached at the position in the function of the computer program which the
 * author has deemed to sufficiently express the reservation of copyright.
 * It is prohibited for customers, users and/or third parties to remove,
 * modify or move this copyright notice.
 * ========================================================================= */

using System;
using Microsoft.Win32;

namespace SoftwareTelemetrySampleCS
{
  public partial class Options : System.Web.UI.Page
  {

    public int m_requestsize;
    public int m_workerthreads;

    protected void Page_Load(object sender, EventArgs e)
    {
    }

    protected void ModifySettings(object sender, EventArgs e)
    {
      m_requestsize = Convert.ToInt32(requestsize.Text);
      m_workerthreads = Convert.ToInt32(workerthreads.Text);
      RegistryKey keySoftware = Registry.LocalMachine.OpenSubKey("Software");
      RegistryKey keyApplStrudl = keySoftware.OpenSubKey("Fabasoft app.telemetry", true);
      RegistryKey keyDemoApplication = keyApplStrudl.CreateSubKey("OnlineShopSample");
      keyDemoApplication.SetValue("RequestSize", m_requestsize, RegistryValueKind.DWord);
      keyDemoApplication.SetValue("WorkerThreads", m_workerthreads, RegistryValueKind.DWord);
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      try
      {
        m_requestsize = 1;
        m_workerthreads = 10;
        RegistryKey keySoftware = Registry.LocalMachine.OpenSubKey("Software");
        RegistryKey keyApplStrudl = keySoftware.OpenSubKey("Fabasoft app.telemetry");
        RegistryKey keyDemoApplication = keyApplStrudl.OpenSubKey("OnlineShopSample");
        m_requestsize = (int)keyDemoApplication.GetValue("RequestSize", 1);
        m_workerthreads = (int)keyDemoApplication.GetValue("WorkerThreads", 10);
      }
      catch
      {
      }
      requestsize.Text = m_requestsize.ToString();
      workerthreads.Text = m_workerthreads.ToString();
    }

  }
}
