// ==========================================================================
// $Workfile: APMModule.h $
// $Revision: 24154 $ of $Date: 2015-10-22 14:38:04 +0200 (Thu, 22 Oct 2015) $
//
// Copyright (c) Fabasoft R&D GmbH, Linz, Austria, 1995-2015.
//
// All rights reserved. All hardware and software names used are registered
// trade names and/or registered trademarks of the respective manufacturers.
//
// The user of this computer program acknowledges that the above copyright
// notice, which constitutes the Universal Copyright Convention, will be
// attached at the position in the function of the computer program which the
// author has deemed to sufficiently express the reservation of copyright.
// It is prohibited for customers, users and/or third parties to remove,
// modify or move this copyright notice.
// ==========================================================================

#import <Foundation/Foundation.h>
#import "APMTransport.h"

@interface APMModule : NSObject {
@private
    APMTransport *m_transport;
    UInt32 m_handle;
    NSString *m_name;
}

- (id)initWithTansport:(APMTransport*)transport
                  name:(NSString*)name
                handle:(UInt32)handle;

- (void)registerEvent:(UInt64)eventId
                 name:(NSString*)name
           parameters:(NSString*)param;

- (void)eventTx:(NSNumber*)thread
             id:(UInt64)eventId
          level:(UInt8)level
          flags:(UInt8)flags;

- (void)eventTx:(NSNumber*)thread
             id:(UInt64)eventId
          level:(UInt8)level
          flags:(UInt8)flags
    stringValue:(NSString*)value;

- (void)eventTx:(NSNumber*)thread
             id:(UInt64)eventId
          level:(UInt8)level
          flags:(UInt8)flags
     parameters:(NSArray*)values;

@end
